extends ../../includes/layout

block content
    style. 
        .btn-w{
            width:95px;
        }

        .r-15{
            margin-right:15px;
        }
        .btn-order{
            margin-bottom: 10px !important;
            width:100%;
            text-align:left;
        }

        .btn-auction{
            margin: 10px;
            width:100px;
        }
    .d-flex.align-items-center.mb-4
        h3.fs-20.font-w600.mb-0.me-auto #{lot.name}
    .row
        .col-xl-5
            .card
                .card-body
                    h3 Order

                    input(type="hidden" name="lotId" id="lotId", value=lot._id)

                    ul
                        each val, index in products

                            li
                                a.btn.btn-info.btn-sm.btn-order(href='javascript:void(0)' attr-id=`${val._id}`)=val.orderNo + ' : ' + val.name

        .col-xl-7
            .card
                .card-body
                    h3 Action

                    .basic-form
                        form
                            .mb-3.row
                                label.col-sm-3.col-form-label Tranline
                                .col-sm-9
                                    input(type="hidden" value=`${product._id}`)#product_id
                                    input.form-control.solid(type='text' readonly required value=`${product.orderNo}`)#product_order
                            .mb-3.row
                                label.col-sm-3.col-form-label Name
                                .col-sm-9
                                    input.form-control.solid(type='text' readonly required value=`${product.name}`)#product_name
                            .mb-3.row
                                label.col-sm-3.col-form-label Step
                                .col-sm-9
                                    input.form-control.solid(type='text' readonly required value=`${product.step}`)#product_step
                            .mb-3.row
                                label.col-sm-3.col-form-label Price Start
                                .col-sm-9
                                    input.form-control.solid(type='text' required value=`${product.startPrice}`)#product_price_start

                            .mb-3.row
                                label.col-sm-3.col-form-label Price Finish
                                .col-sm-9
                                    input.form-control.solid(type='text' required value=`${product.finishPrice}`)#product_price_finish
                            .mb-3.row
                                label.col-sm-3.col-form-label Label Win
                                .col-sm-9
                                    input.form-control.solid(type='text' required value=`${product.userWin}`)#product_win
                            .mb-3.row
                                .col-sm-10
                                    button.btn.btn-success.btn-sm.btn-auction(type='button' data-type="sold") Sold
                                    button.btn.btn-info.btn-sm.btn-auction(type='button' data-type="stop") Stop
                                    button.btn.btn-primary.btn-sm.btn-auction(type='button' data-type="back") Back
                                    button.btn.btn-warning.btn-sm.btn-auction(type='button' data-type="reset") Reset

block script
    script(src='/socket.io/socket.io.js')
    script.
        const socket = io();
        const lot_id = $('#lotId').val()

        let product_id = $('#product_id').val()
        let product_order = $('#product_order').val()
        let product_name = $('#product_name').val()
        let product_price_start = $('#product_price_start').val()
        let product_price_finish = $('#product_price_finish').val()
        let product_win = $('#product_win').val()
        let product_step = $('#product_step').val()

        console.log('product_id : ',product_id)
        console.log('product_order : ',product_order)
        console.log('product_name : ',product_name)
        console.log('product_price_start : ',product_price_start)
        console.log('product_price_finish : ',product_price_finish)
        console.log('product_win : ',product_win)
        console.log('access_token : ',access_token)
        console.log('product_step : ',product_step)

        load_product(product_id)

        console.log('socket : ',socket)

        socket.emit("join", lot_id);

        socket.on('setBid', function(result) {
            console.log('------------------------------')
            console.log('socket : ',result.datas)
            console.log('product_price_finish : ',result.datas.product_price_finish)
            console.log('product_id : ',product_id)

            $('#product_price_finish').val(result.datas.product_price_finish)

        });

        $('.btn-order').click(function(){
            product_id = $(this).attr('attr-id')
            console.log('product_id : ',product_id)
            load_product()

        })


        function load_product(){

            $.ajax({
                url: "#{base_url}admin/auction/load_product",
                headers: {
                    'Authorization': 'Bearer '+access_token,
                },
                method: "POST",
                dataType: "json",
                data:{
                    product_id:product_id,
                    type:'set'
                },
                success: function (res, status, xhr) {
                    if(status=='success' && xhr.status==200 && res.result){
                        console.log(res)

                        product_price_finish = res.product.finishPrice
                        product_win = res.product.userWin
                        product_step =res.product.step

                        $('#product_id').val(res.product._id)
                        $('#product_order').val(res.product.orderNo)
                        $('#product_name').val(res.product.name)
                        $('#product_price_start').val(res.product.startPrice)
                        $('#product_step').val(res.product.step)

                        if(product_price_finish=='' || product_price_finish==null){

                            $('#product_price_finish').val(res.product.startPrice)
                        }else{
                            $('#product_price_finish').val(product_price_finish)
                        }

                        $('#product_win').val(product_win)

                        socket.emit('setBid', lot_id,{product_id,product_price_finish,product_win},function (res) {
                            console.log(res)
                        });

                    }else{
                        sweetAlert("Oops...", data.message, "error");
                    }
                },
                error: function (xhr, status, error) {
                    alert_error(xhr,error)
                },
            });

        }

        $('#btn_bid').click(function(){
            let product_price_finish = parseInt($('#product_price_finish').val())

            product_price_finish = product_price_finish+product_step


            $('#product_price_finish').val(product_price_finish)


            bid_product()

        })

        function bid_product(){

            let product_price_finish = $('#product_price_finish').val()
            let product_win = $('#product_win').val()

            socket.emit('setBid', lot_id,{product_id,product_price_finish,product_win},function (res) {
                console.log(res)
            });


        }

        $('.btn-auction').click(function(){
            let type = $(this).data('type')
            console.log('type:',type)

            swal({
                title: "Are you sure?",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: '#DD6B55',
                confirmButtonText: 'Yes, I am sure!',
                cancelButtonText: "No, cancel it!"
            }).then(function(result) {
             
                if(result.value){
                    console.log('product_id : ',product_id)

                    if(type=='sold'){
                        confirm_product()
                    }else if(type=='reset'){
                        reset_product()
                    }else if(type=='back'){
                        back_product()
                    }else if(type=='stop'){
                        stop_product()
                    }

                }
            })


        })

        function reset_product(){

        }

        function back_product(){

        }

        function stop_product(){

        }

        function confirm_product(){

            let product_price_finish = parseInt($('#product_price_finish').val())

            let product_win = $('#product_win').val()

            $.ajax({
                url: "#{base_url}admin/auction/confirm_product",
                headers: {
                    'Authorization': 'Bearer '+access_token,
                },
                method: "POST",
                dataType: "json",
                data:{
                    product_id:product_id,
                    product_price_finish: product_price_finish,
                    product_win: product_win,
                },
                success: function (res, status, xhr) {

                    if(xhr.status==201 && res.result){
                        console.log(res)
                        let status = 'sold'
                        socket.emit('setBid', lot_id,{product_id,product_price_finish,product_win,user_id,status},function (res) {
                            console.log(res)
                        });

                        sweetAlert("Product Confirm", 'Success', "success")

                    }else{
                        sweetAlert("Oops...", data.message, "error");
                    }
                },
                error: function (xhr, status, error) {
                    alert_error(xhr,error)
                },
            });
        }

        socket.on('setBid', function(datas) {
            console.log('datas : ',datas)
        });

